#ifndef SIMPLESTOPPEUR_H
#define SIMPLESTOPPEUR_H

#include "Mutex.h"

class SimpleStoppeur
{
   bool arret_demande_, arret_complete_;
   Mutex mutex_;
public:
   SimpleStoppeur()
      : arret_demande_(false), arret_complete_(false)
   {
   }
   void demander_arret() volatile throw()
   {
      Autoverrou a(mutex_);
      arret_demande_ = true;
   }
   bool arret_demande() const volatile throw()
      { return arret_demande_; }
   void arret_complete() volatile throw()
   {
      Autoverrou a(mutex_);
      arret_complete_ = true;
   }
   bool est_arrete() const volatile throw()
      { return arret_complete_; }
};

#endif
