#include "StrateIsolante.h"
#include <winsock2.h>
#include <iostream>
using std::cerr;
using std::endl;
#include <string>
using std::string;

bool est_invalide(const socket_t sck) throw()
   { return sck == INVALID_SOCKET; }

bool est_erreur(const socket_operation_t op) throw()
   { return op == SOCKET_ERROR; }

int erreur(const std::string &msg)
{
   const int code = ::WSAGetLastError();
   cerr << msg << "; erreur " << code << endl;
   return code;
}

void charger_sockets()
{
   const long VERSION_DEMANDEE = MAKEWORD(2,2);
   WSAData configWinsock;
   if (WSAStartup(VERSION_DEMANDEE, &configWinsock) != 0)
      exit(erreur("Dmarrage"));
}

void decharger_sockets() throw()
   { WSACleanup(); }

socket_t creer_socket()
{
   socket_t sck =
      socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
   if (est_invalide(sck))
      exit(erreur("Cration"));
   return sck;
}

void connecter
   (socket_t sck, const string &adresse, const short port)
{
   sockaddr_in dest = { 0 };
   dest.sin_family= AF_INET;
   dest.sin_addr.s_addr=
      inet_addr (adresse.c_str ());
   dest.sin_port = port;
   socket_operation_t resultat = connect
      (sck, reinterpret_cast<const sockaddr*>(&dest),
            sizeof(sockaddr_in));
   if (est_erreur(resultat))
      exit(erreur("Connexion"));
}

void reserver_port(const socket_t sck, const short port)
{
   sockaddr_in nom = { 0 };
   nom.sin_family = AF_INET;
   nom.sin_port = port;
   socket_operation_t resultat = bind
      (sck, reinterpret_cast<const sockaddr*>(&nom),
            sizeof(sockaddr_in));
   if (est_erreur(resultat))
   {
      cerr << "Port " << htons(port) << ", ";
      exit(erreur("Obtention"));
   }
   // Crer la file dattente pour demandes de connexion
   int taille_file_attente = 16; // arbitraire
   if (est_erreur(listen(sck, taille_file_attente)))
      exit(erreur("Crer file d'attente"));
}

socket_t accepter_client(const socket_t srv)
{
   sockaddr_in homologue = { 0 };
   int taille_homologue= sizeof(sockaddr_in);
   socket_t sck =
      accept(srv, reinterpret_cast<sockaddr *>(&homologue),
             &taille_homologue);
   if (est_invalide(sck))
      exit(erreur("Accepter connexion"));
   return sck;
}

string recevoir(const socket_t sck, const char FIN)
{
   const int TAILLE_TAMPON = 64; // arbitraire
   char tampon[TAILLE_TAMPON];
   string message_recu;
   bool reception_completee = false;
   do
   {
      socket_operation_t n =
         recv(sck, tampon, TAILLE_TAMPON, 0);
      if (est_erreur (n))
         exit(erreur("Rception"));
      message_recu.append(tampon, tampon + n);
      if (tampon[n-1] == FIN)
         reception_completee = true;
   }
   while (!reception_completee);
   return message_recu.substr(0, message_recu.size()-1);
}

void envoyer(const socket_t sck, string msg, const char FIN)
{
   msg += FIN;
   while (!msg.empty())
   {
      socket_operation_t plus_recent =
         send(sck, msg.c_str(), static_cast<int>(msg.size()), 0);
      if (est_erreur(plus_recent))
         exit(erreur("Envoi"));
      msg = msg.substr(plus_recent);
   }
}

void fermer_socket(const socket_t sck) throw()
{
   shutdown(sck, SD_BOTH);
   closesocket(sck);
}

void invalider_socket(socket_t &sck)
   { sck = INVALID_SOCKET; }
